From b6923420f326ac030e4f3ef89a2acddb45eccb30 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Marko=20M=C3=A4kel=C3=A4?= <marko.makela@mariadb.com>
Date: Wed, 26 Mar 2025 17:05:44 +0200
Subject: [PATCH] MDEV-29445: Reimplement SET GLOBAL innodb_buffer_pool_size

We deprecate and ignore the parameter innodb_buffer_pool_chunk_size
and let the buffer pool size to be changed in arbitrary 1-megabyte
increments.

innodb_buffer_pool_size_max: A new read-only startup parameter
that specifies the maximum innodb_buffer_pool_size.  If 0 or
unspecified, it will default to the specified innodb_buffer_pool_size
rounded up to the allocation unit (2 MiB or 8 MiB).  The maximum value
is 4GiB-2MiB on 32-bit systems and 16EiB-8MiB on 64-bit systems.
This maximum is very likely to be limited further by the operating system.

The status variable Innodb_buffer_pool_resize_status will reflect
the status of shrinking the buffer pool. When no shrinking is in
progress, the string will be empty.

Unlike before, the execution of SET GLOBAL innodb_buffer_pool_size
will block until the requested buffer pool size change has been
implemented, or the execution is interrupted by a KILL statement
a client disconnect, or server shutdown.  If the
buf_flush_page_cleaner() thread notices that we are running out of
memory, the operation may fail with ER_WRONG_USAGE.

SET GLOBAL innodb_buffer_pool_size will be refused
if the server was started with --large-pages (even if
no HugeTLB pages were successfully allocated). This functionality
is somewhat exercised by the test main.large_pages, which now runs
also on Microsoft Windows.  On Linux, explicit HugeTLB mappings are
apparently excluded from the reported Redident Set Size (RSS), and
apparently unshrinkable between mmap(2) and munmap(2).

The buffer pool will be mapped to a contiguous virtual memory area
that will be aligned and partitioned into extents of 8 MiB on
64-bit systems and 2 MiB on 32-bit systems.

Within an extent, the first few innodb_page_size blocks contain
buf_block_t objects that will cover the page frames in the rest
of the extent.  The number of such frames is precomputed in the
array first_page_in_extent[] for each innodb_page_size.
In this way, there is a trivial mapping between
page frames and block descriptors and we do not need any
lookup tables like buf_pool.zip_hash or buf_pool_t::chunk_t::map.

We will always allocate the same number of block descriptors for
an extent, even if we do not need all the buf_block_t in the last
extent in case the innodb_buffer_pool_size is not an integer multiple
of the of extents size.

The minimum innodb_buffer_pool_size is 256*5/4 pages.  At the default
innodb_page_size=16k this corresponds to 5 MiB.  However, now that the
innodb_buffer_pool_size includes the memory allocated for the block
descriptors, the minimum would be innodb_buffer_pool_size=6m.

my_large_virtual_alloc(): A new function, similar to my_large_malloc().

my_virtual_mem_reserve(), my_virtual_mem_commit(),
my_virtual_mem_decommit(), my_virtual_mem_release():
New interface mostly by Vladislav Vaintroub, to separately
reserve and release virtual address space, as well as to
commit and decommit memory within it.

After my_virtual_mem_decommit(), the virtual memory range will be
read-only or unaccessible, depending on whether the build option
cmake -DHAVE_UNACCESSIBLE_AFTER_MEM_DECOMMIT=1
has been specified.  This option is hard-coded on Microsoft Windows,
where VirtualMemory(MEM_DECOMMIT) will make the memory unaccessible.
On IBM AIX, Linux, Illumos and possibly Apple macOS, the virtual memory
will be zeroed out immediately.  On other POSIX-like systems,
madvise(MADV_FREE) will be used if available, to give the operating
system kernel a permission to zero out the virtual memory range.
We prefer immediate freeing so that the reported
resident set size (RSS) of the process will reflect the current
innodb_buffer_pool_size.  Shrinking the buffer pool is a rarely
executed resource intensive operation, and the immediate configuration
of the MMU mappings should not incur significant additional penalty.

opt_super_large_pages: Declare only on Solaris. Actually, this is
specific to the SPARC implementation of Solaris, but because we
lack access to a Solaris development environment, we will not revise
this for other MMU and ISA.

buf_pool_t::chunk_t::create(): Remove.

buf_pool_t::create(): Initialize all n_blocks of the buf_pool.free list.

buf_pool_t::allocate(): Renamed from buf_LRU_get_free_only().

buf_pool_t::LRU_warned: Changed to Atomic_relaxed<bool>,
only to be modified by the buf_flush_page_cleaner() thread.

buf_pool_t::shrink(): Attempt to shrink the buffer pool.
There are 3 possible outcomes: SHRINK_DONE (success),
SHRINK_IN_PROGRESS (the caller may keep trying),
and SHRINK_ABORT (we seem to be running out of buffer pool).
While traversing buf_pool.LRU, release the contended
buf_pool.mutex once in every 32 iterations in order to
reduce starvation. Use lru_scan_itr for efficient traversal,
similar to buf_LRU_free_from_common_LRU_list().

buf_pool_t::shrunk(): Update the reduced size of the buffer pool
in a way that is compatible with buf_pool_t::page_guess(),
and invoke my_virtual_mem_decommit().

buf_pool_t::resize(): Before invoking shrink(), run one batch of
buf_flush_page_cleaner() in order to prevent LRU_warn().
Abort if shrink() recommends it, or no blocks were withdrawn in
the past 15 seconds, or the execution of the statement
SET GLOBAL innodb_buffer_pool_size was interrupted.

buf_pool_t::first_to_withdraw: The first block descriptor that is
out of the bounds of the shrunk buffer pool.

buf_pool_t::withdrawn: The list of withdrawn blocks.
If buf_pool_t::resize() is aborted before shrink() completes,
we must be able to resurrect the withdrawn blocks in the free list.

buf_pool_t::contains_zip(): Added a parameter for the
number of least significant pointer bits to disregard,
so that we can find any pointers to within a block
that is supposed to be free.

buf_pool_t::is_shrinking(): Return the total number or blocks that
were withdrawn or are to be withdrawn.

buf_pool_t::to_withdraw(): Return the number of blocks that will need to
be withdrawn.

buf_pool_t::usable_size(): Number of usable pages, considering possible
in-progress attempt at shrinking the buffer pool.

buf_pool_t::page_guess(): Try to buffer-fix a guessed block pointer.
If HAVE_UNACCESSIBLE_AFTER_MEM_DECOMMIT is set, the pointer will
be validated before being dereferenced.

buf_pool_t::get_info(): Replaces buf_stats_get_pool_info().

innodb_init_param(): Refactored. We must first compute
srv_page_size_shift and then determine the valid bounds of
innodb_buffer_pool_size.

buf_buddy_shrink(): Replaces buf_buddy_realloc().
Part of the work is deferred to buf_buddy_condense_free(),
which is being executed when we are not holding any
buf_pool.page_hash latch.

buf_buddy_condense_free(): Do not relocate blocks.

buf_buddy_free_low(): Do not care about buffer pool shrinking.
This will be handled by buf_buddy_shrink() and
buf_buddy_condense_free().

buf_buddy_alloc_zip(): Assert !buf_pool.contains_zip()
when we are allocating from the binary buddy system.
Previously we were asserting this on multiple recursion levels.

buf_buddy_block_free(), buf_buddy_free_low():
Assert !buf_pool.contains_zip().

buf_buddy_alloc_from(): Remove the redundant parameter j.

buf_flush_LRU_list_batch(): Add the parameter to_withdraw
to keep track of buf_pool.n_blocks_to_withdraw.

buf_do_LRU_batch(): Skip buf_free_from_unzip_LRU_list_batch()
if we are shrinking the buffer pool. In that case, we want
to minimize the page relocations and just finish as quickly
as possible.

trx_purge_attach_undo_recs(): Limit purge_sys.n_pages_handled()
in every iteration, in case the buffer pool is being shrunk
in the middle of a purge batch.

Reviewed by: Debarun Banerjee
---
 cmake/os/Windows.cmake                        |    1 +
 config.h.cmake                                |    5 +
 extra/mariabackup/innobackupex.cc             |    7 +-
 extra/mariabackup/xtrabackup.cc               |   13 +-
 include/my_sys.h                              |    6 +-
 include/my_virtual_mem.h                      |   35 +
 mysql-test/main/large_pages.opt               |    2 +-
 mysql-test/main/large_pages.result            |    1 +
 mysql-test/main/large_pages.test              |    4 +-
 .../t/innodb_encrypt_temporary_tables.opt     |    2 +-
 .../suite/innodb/r/buf_pool_resize_oom.result |    8 -
 .../innodb/r/innodb_buffer_pool_fail.result   |    4 +-
 .../innodb/r/innodb_buffer_pool_resize.result |   35 +-
 .../innodb_buffer_pool_resize_bigtest.result  |   14 -
 ...innodb_buffer_pool_resize_temporary.result |   25 +
 ...nodb_buffer_pool_resize_with_chunks.result |   26 -
 .../suite/innodb/r/lock_memory_debug.result   |    2 +-
 .../innodb/r/log_upgrade_101_flags.result     |    2 +-
 .../suite/innodb/r/recovery_memory.result     |    2 +-
 mysql-test/suite/innodb/r/restart,16k.rdiff   |   16 -
 mysql-test/suite/innodb/r/restart,32k.rdiff   |   16 -
 mysql-test/suite/innodb/r/restart,4k.rdiff    |   16 -
 mysql-test/suite/innodb/r/restart,64k.rdiff   |   16 -
 mysql-test/suite/innodb/r/restart,8k.rdiff    |   16 -
 mysql-test/suite/innodb/r/restart.result      |   13 -
 .../suite/innodb/t/buf_pool_resize_oom.opt    |    1 -
 .../suite/innodb/t/buf_pool_resize_oom.test   |   27 -
 .../suite/innodb/t/innodb-index-online.opt    |    2 +-
 .../innodb/t/innodb-table-online-master.opt   |    2 +-
 .../innodb/t/innodb_buffer_pool_fail.opt      |    1 +
 .../innodb/t/innodb_buffer_pool_fail.test     |    4 +-
 .../innodb/t/innodb_buffer_pool_resize.opt    |    1 +
 .../innodb/t/innodb_buffer_pool_resize.test   |   64 +-
 .../t/innodb_buffer_pool_resize_bigtest.opt   |    2 -
 .../t/innodb_buffer_pool_resize_bigtest.test  |   28 -
 .../t/innodb_buffer_pool_resize_debug.opt     |    1 -
 .../t/innodb_buffer_pool_resize_temporary.opt |    1 +
 .../innodb_buffer_pool_resize_temporary.test  |   35 +-
 .../innodb_buffer_pool_resize_with_chunks.opt |    3 -
 ...innodb_buffer_pool_resize_with_chunks.test |   61 -
 .../suite/innodb/t/lock_memory_debug.opt      |    2 +-
 .../suite/innodb/t/lock_memory_debug.test     |    2 +-
 .../suite/innodb/t/log_upgrade_101_flags.test |    2 +-
 mysql-test/suite/innodb/t/mem_pressure.opt    |    2 +
 mysql-test/suite/innodb/t/mem_pressure.test   |    1 -
 mysql-test/suite/innodb/t/purge_secondary.opt |    2 +-
 .../suite/innodb/t/recovery_memory.test       |    6 +-
 mysql-test/suite/innodb/t/restart.opt         |    2 -
 mysql-test/suite/innodb/t/restart.test        |   25 -
 .../suite/innodb/t/update_time-master.opt     |    1 -
 .../r/innodb_buffer_pool_size_basic.result    |   30 +-
 .../sys_vars/r/sysvars_innodb,32bit.rdiff     |   86 +-
 .../suite/sys_vars/r/sysvars_innodb.result    |   17 +-
 .../innodb_buffer_pool_size_basic-master.opt  |    1 -
 .../t/innodb_buffer_pool_size_basic.opt       |    1 +
 .../t/innodb_buffer_pool_size_basic.test      |   37 +-
 .../suite/sys_vars/t/sysvars_innodb.test      |    1 +
 mysys/CMakeLists.txt                          |    3 +-
 mysys/my_largepage.c                          |  151 +-
 mysys/my_virtual_mem.c                        |  207 ++
 sql/mysql_install_db.cc                       |    2 +-
 sql/mysqld.cc                                 |    6 +-
 storage/innobase/btr/btr0sea.cc               |  104 +-
 storage/innobase/buf/buf0buddy.cc             |  318 +--
 storage/innobase/buf/buf0buf.cc               | 2292 ++++++++---------
 storage/innobase/buf/buf0dump.cc              |    8 +-
 storage/innobase/buf/buf0flu.cc               |   48 +-
 storage/innobase/buf/buf0lru.cc               |  136 +-
 storage/innobase/buf/buf0rea.cc               |    7 +-
 storage/innobase/dict/dict0dict.cc            |    4 +-
 storage/innobase/handler/ha_innodb.cc         |  702 ++---
 storage/innobase/handler/i_s.cc               |  110 +-
 storage/innobase/ibuf/ibuf0ibuf.cc            |    7 +-
 storage/innobase/include/btr0sea.h            |   10 +-
 storage/innobase/include/buf0buddy.h          |   40 +-
 storage/innobase/include/buf0buf.h            |  439 ++--
 storage/innobase/include/buf0buf.inl          |    2 +-
 storage/innobase/include/buf0lru.h            |    4 -
 storage/innobase/include/srv0srv.h            |   13 +-
 storage/innobase/log/log0log.cc               |    9 +-
 storage/innobase/log/log0recv.cc              |   40 +-
 storage/innobase/mtr/mtr0mtr.cc               |    2 +-
 storage/innobase/srv/srv0mon.cc               |    9 +-
 storage/innobase/srv/srv0srv.cc               |   24 +-
 storage/innobase/srv/srv0start.cc             |   21 -
 storage/innobase/trx/trx0purge.cc             |    7 +-
 86 files changed, 2490 insertions(+), 2973 deletions(-)
 create mode 100644 include/my_virtual_mem.h
 delete mode 100644 mysql-test/suite/innodb/r/buf_pool_resize_oom.result
 delete mode 100644 mysql-test/suite/innodb/r/innodb_buffer_pool_resize_bigtest.result
 delete mode 100644 mysql-test/suite/innodb/r/innodb_buffer_pool_resize_with_chunks.result
 delete mode 100644 mysql-test/suite/innodb/r/restart,16k.rdiff
 delete mode 100644 mysql-test/suite/innodb/r/restart,32k.rdiff
 delete mode 100644 mysql-test/suite/innodb/r/restart,4k.rdiff
 delete mode 100644 mysql-test/suite/innodb/r/restart,64k.rdiff
 delete mode 100644 mysql-test/suite/innodb/r/restart,8k.rdiff
 delete mode 100644 mysql-test/suite/innodb/t/buf_pool_resize_oom.opt
 delete mode 100644 mysql-test/suite/innodb/t/buf_pool_resize_oom.test
 create mode 100644 mysql-test/suite/innodb/t/innodb_buffer_pool_fail.opt
 delete mode 100644 mysql-test/suite/innodb/t/innodb_buffer_pool_resize_bigtest.opt
 delete mode 100644 mysql-test/suite/innodb/t/innodb_buffer_pool_resize_bigtest.test
 delete mode 100644 mysql-test/suite/innodb/t/innodb_buffer_pool_resize_debug.opt
 create mode 100644 mysql-test/suite/innodb/t/innodb_buffer_pool_resize_temporary.opt
 delete mode 100644 mysql-test/suite/innodb/t/innodb_buffer_pool_resize_with_chunks.opt
 delete mode 100644 mysql-test/suite/innodb/t/innodb_buffer_pool_resize_with_chunks.test
 create mode 100644 mysql-test/suite/innodb/t/mem_pressure.opt
 delete mode 100644 mysql-test/suite/innodb/t/restart.opt
 delete mode 100644 mysql-test/suite/innodb/t/update_time-master.opt
 delete mode 100644 mysql-test/suite/sys_vars/t/innodb_buffer_pool_size_basic-master.opt
 create mode 100644 mysql-test/suite/sys_vars/t/innodb_buffer_pool_size_basic.opt
 create mode 100644 mysys/my_virtual_mem.c

Index: mariadb-10.11.11/cmake/os/Windows.cmake
===================================================================
--- mariadb-10.11.11.orig/cmake/os/Windows.cmake
+++ mariadb-10.11.11/cmake/os/Windows.cmake
@@ -282,6 +282,7 @@ STRING(APPEND CMAKE_CXX_STANDARD_LIBRARI
 
 # System checks
 SET(SIGNAL_WITH_VIO_CLOSE 1) # Something that runtime team needs
+SET(HAVE_UNACCESSIBLE_AFTER_MEM_DECOMMIT 1)
 
 # IPv6 constants appeared in Vista SDK first. We need to define them in any case if they are 
 # not in headers, to handle dual mode sockets correctly.
Index: mariadb-10.11.11/config.h.cmake
===================================================================
--- mariadb-10.11.11.orig/config.h.cmake
+++ mariadb-10.11.11/config.h.cmake
@@ -457,6 +457,11 @@
 /* This should mean case insensitive file system */
 #cmakedefine FN_NO_CASE_SENSE 1
 
+/* Whether an anonymous private mapping is unaccessible after
+madvise(MADV_DONTNEED) or madvise(MADV_FREE) or similar has been invoked;
+this is the case with Microsoft Windows VirtualFree(MEM_DECOMMIT) */
+#cmakedefine HAVE_UNACCESSIBLE_AFTER_MEM_DECOMMIT 1
+
 #cmakedefine HAVE_CHARSET_armscii8 1
 #cmakedefine HAVE_CHARSET_ascii 1
 #cmakedefine HAVE_CHARSET_big5 1
Index: mariadb-10.11.11/extra/mariabackup/innobackupex.cc
===================================================================
--- mariadb-10.11.11.orig/extra/mariabackup/innobackupex.cc
+++ mariadb-10.11.11/extra/mariabackup/innobackupex.cc
@@ -44,8 +44,8 @@ Street, Fifth Floor, Boston, MA 02110-13
 #include <string.h>
 #include <mysql.h>
 #include <my_dir.h>
-#include <ut0mem.h>
 #include <os0file.h>
+#include "buf0buf.h"
 #include <srv0start.h>
 #include <algorithm>
 #include <mysqld.h>
@@ -594,8 +594,9 @@ static struct my_option ibx_long_options
 	 "--apply-log.",
 	 (uchar*) &ibx_xtrabackup_use_memory,
 	 (uchar*) &ibx_xtrabackup_use_memory,
-	 0, GET_LL, REQUIRED_ARG, 100*1024*1024L, 1024*1024L, LONGLONG_MAX, 0,
-	 1024*1024L, 0},
+	 0, GET_LL, REQUIRED_ARG, 96 << 20,
+	 innodb_buffer_pool_extent_size, SIZE_T_MAX, 0,
+	 innodb_buffer_pool_extent_size, 0},
 
 	{"innodb-force-recovery", OPT_INNODB_FORCE_RECOVERY,
 	 "This option starts up the embedded InnoDB instance in crash "
Index: mariadb-10.11.11/extra/mariabackup/xtrabackup.cc
===================================================================
--- mariadb-10.11.11.orig/extra/mariabackup/xtrabackup.cc
+++ mariadb-10.11.11/extra/mariabackup/xtrabackup.cc
@@ -1414,8 +1414,8 @@ struct my_option xb_client_options[]= {
      "The value is used in place of innodb_buffer_pool_size. "
      "This option is only relevant when the --prepare option is specified.",
      (G_PTR *) &xtrabackup_use_memory, (G_PTR *) &xtrabackup_use_memory, 0,
-     GET_LL, REQUIRED_ARG, 100 * 1024 * 1024L, 1024 * 1024L, LONGLONG_MAX, 0,
-     1024 * 1024L, 0},
+     GET_LL, REQUIRED_ARG, 96 << 20, innodb_buffer_pool_extent_size,
+     SIZE_T_MAX, 0, innodb_buffer_pool_extent_size, 0},
     {"throttle", OPT_XTRA_THROTTLE,
      "limit count of IO operations (pairs of read&write) per second to IOS "
      "values (for '--backup')",
@@ -2482,7 +2482,7 @@ static bool innodb_init_param()
 	}
 
 	srv_sys_space.normalize_size();
-	srv_lock_table_size = 5 * (srv_buf_pool_size >> srv_page_size_shift);
+	srv_lock_table_size = 5 * buf_pool.curr_size();
 
 	/* -------------- Log files ---------------------------*/
 
@@ -2504,11 +2504,8 @@ static bool innodb_init_param()
 
 	srv_adaptive_flushing = FALSE;
 
-        /* We set srv_pool_size here in units of 1 kB. InnoDB internally
-        changes the value so that it becomes the number of database pages. */
-
-	srv_buf_pool_size = (ulint) xtrabackup_use_memory;
-	srv_buf_pool_chunk_unit = srv_buf_pool_size;
+	buf_pool.size_in_bytes_max = size_t(xtrabackup_use_memory);
+	buf_pool.size_in_bytes_requested = buf_pool.size_in_bytes_max;
 
 	srv_n_read_io_threads = (uint) innobase_read_io_threads;
 	srv_n_write_io_threads = (uint) innobase_write_io_threads;
Index: mariadb-10.11.11/include/my_sys.h
===================================================================
--- mariadb-10.11.11.orig/include/my_sys.h
+++ mariadb-10.11.11/include/my_sys.h
@@ -173,9 +173,13 @@ extern void my_free(void *ptr);
 extern void *my_memdup(PSI_memory_key key, const void *from,size_t length,myf MyFlags);
 extern char *my_strdup(PSI_memory_key key, const char *from,myf MyFlags);
 extern char *my_strndup(PSI_memory_key key, const char *from, size_t length, myf MyFlags);
+extern my_bool my_use_large_pages;
 
-int my_init_large_pages(my_bool super_large_pages);
+int my_init_large_pages(void);
 uchar *my_large_malloc(size_t *size, myf my_flags);
+#if defined _WIN32 || defined HAVE_MMAP
+char *my_large_virtual_alloc(size_t *size);
+#endif
 void my_large_free(void *ptr, size_t size);
 void my_large_page_truncate(size_t *size);
 
Index: mariadb-10.11.11/include/my_virtual_mem.h
===================================================================
--- /dev/null
+++ mariadb-10.11.11/include/my_virtual_mem.h
@@ -0,0 +1,35 @@
+/* Copyright (c) 2025, MariaDB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1335  USA */
+
+#pragma once
+/*
+  Functionality for handling virtual memory
+  (reserve, commit, decommit, release)
+*/
+#include <stddef.h> /*size_t*/
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+char *my_virtual_mem_reserve(size_t *size);
+char *my_virtual_mem_commit(char *ptr, size_t size);
+void my_virtual_mem_decommit(char *ptr, size_t size);
+void my_virtual_mem_release(char *ptr, size_t size);
+
+#ifdef __cplusplus
+}
+#endif
+
Index: mariadb-10.11.11/mysql-test/main/large_pages.opt
===================================================================
--- mariadb-10.11.11.orig/mysql-test/main/large_pages.opt
+++ mariadb-10.11.11/mysql-test/main/large_pages.opt
@@ -1 +1 @@
---large-pages
+--large-pages --loose-innodb-buffer-pool-size-max=16m
Index: mariadb-10.11.11/mysql-test/main/large_pages.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/main/large_pages.result
+++ mariadb-10.11.11/mysql-test/main/large_pages.result
@@ -1,4 +1,5 @@
 call mtr.add_suppression("\\[Warning\\] (mysqld|mariadbd): Couldn't allocate [0-9]+ bytes \\((Large/HugeTLB memory|MEMLOCK) page size [0-9]+\\).*");
+call mtr.add_suppression("\\[ERROR\\]*Lock Pages in memory access rights required.*");
 create table t1 (
 a int not null auto_increment,
 b char(16) not null,
Index: mariadb-10.11.11/mysql-test/main/large_pages.test
===================================================================
--- mariadb-10.11.11.orig/mysql-test/main/large_pages.test
+++ mariadb-10.11.11/mysql-test/main/large_pages.test
@@ -1,11 +1,9 @@
 # Test of large pages (or at least the fallback to conventional allocation)
 
-# Windows needs SeLockMemoryPrivilege
---source include/not_windows.inc
 --source include/have_innodb.inc
 
 call mtr.add_suppression("\\[Warning\\] (mysqld|mariadbd): Couldn't allocate [0-9]+ bytes \\((Large/HugeTLB memory|MEMLOCK) page size [0-9]+\\).*");
-
+call mtr.add_suppression("\\[ERROR\\]*Lock Pages in memory access rights required.*");
 create table t1 (
   a int not null auto_increment,
   b char(16) not null,
Index: mariadb-10.11.11/mysql-test/suite/encryption/t/innodb_encrypt_temporary_tables.opt
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/encryption/t/innodb_encrypt_temporary_tables.opt
+++ mariadb-10.11.11/mysql-test/suite/encryption/t/innodb_encrypt_temporary_tables.opt
@@ -1,2 +1,2 @@
---innodb_buffer_pool_size=5M
+--innodb_buffer_pool_size=6M
 --innodb_encrypt_temporary_tables=1
Index: mariadb-10.11.11/mysql-test/suite/innodb/r/innodb_buffer_pool_fail.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/r/innodb_buffer_pool_fail.result
+++ mariadb-10.11.11/mysql-test/suite/innodb/r/innodb_buffer_pool_fail.result
@@ -1,4 +1,4 @@
-call mtr.add_suppression("InnoDB: Cannot allocate memory for the buffer pool");
+call mtr.add_suppression("InnoDB: Cannot map innodb_buffer_pool_size_max=");
 call mtr.add_suppression("InnoDB: Plugin initialization aborted at srv0start.cc.*");
 call mtr.add_suppression("Plugin 'InnoDB' init function returned error.");
 call mtr.add_suppression("Plugin 'InnoDB' registration as a STORAGE ENGINE failed.");
@@ -6,4 +6,4 @@ call mtr.add_suppression("Plugin 'InnoDB
 # MDEV-25019 memory allocation failures during startup cause server failure in different, confusing ways
 #
 # restart: --debug_dbug=+d,ib_buf_chunk_init_fails
-FOUND 1 /\[ERROR\] InnoDB: Cannot allocate memory for the buffer pool/ in mysqld.1.err
+FOUND 1 /\[ERROR\] InnoDB: Cannot map innodb_buffer_pool_size_max=16m/ in mysqld.1.err
Index: mariadb-10.11.11/mysql-test/suite/innodb/r/innodb_buffer_pool_resize.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/r/innodb_buffer_pool_resize.result
+++ mariadb-10.11.11/mysql-test/suite/innodb/r/innodb_buffer_pool_resize.result
@@ -1,27 +1,28 @@
+#
+# MDEV-29445: Reorganize buffer pool (and remove chunks)
+#
 set global innodb_adaptive_hash_index=ON;
 select @@innodb_buffer_pool_size;
 @@innodb_buffer_pool_size
 8388608
+set global innodb_buffer_pool_size = 9437184;
 set global innodb_buffer_pool_size = 10485760;
 select @@innodb_buffer_pool_size;
 @@innodb_buffer_pool_size
 10485760
-create table t1 (id int not null, val int not null default '0', primary key (id)) ENGINE=InnoDB ROW_FORMAT=COMPRESSED;
-create or replace view view0 as select 1 union all select 1;
-set @`v_id` := 0;
-set @`v_val` := 0;
-replace into t1 select (@`v_id` := (@`v_id` + 4) mod 4294967296) as id, (@`v_val` := (@`v_val` + 4) mod 4294967296) as val from view0 v0, view0 v1, view0 v2, view0 v3, view0 v4, view0 v5, view0 v6, view0 v7, view0 v8, view0 v9, view0 v10, view0 v11, view0 v12, view0 v13, view0 v14, view0 v15, view0 v16, view0 v17;
-set global innodb_buffer_pool_size = 64 * 1024 * 1024 + 512 * 1024;
-Warnings:
-Warning	1292	Truncated incorrect innodb_buffer_pool_size value: '67633152'
-select @@innodb_buffer_pool_size;
-@@innodb_buffer_pool_size
-68157440
+create table t1 (id int primary key, val int not null)
+ENGINE=InnoDB ROW_FORMAT=COMPRESSED;
+SET STATEMENT foreign_key_checks=0, unique_checks=0 FOR
+INSERT INTO t1 SELECT seq*4,seq*4 FROM seq_1_to_262144;
+set global innodb_buffer_pool_size = 7340032;
 select count(val) from t1;
 count(val)
 262144
 set global innodb_adaptive_hash_index=OFF;
-set global innodb_buffer_pool_size = 25165824;
+set global innodb_buffer_pool_size = 24117248;
+set global innodb_buffer_pool_size = 26214400;
+Warnings:
+Warning	1292	Truncated incorrect innodb_buffer_pool_size value: '26214400'
 select @@innodb_buffer_pool_size;
 @@innodb_buffer_pool_size
 25165824
@@ -29,4 +30,12 @@ select count(val) from t1;
 count(val)
 262144
 drop table t1;
-drop view view0;
+SET GLOBAL innodb_max_purge_lag_wait = 0;
+SET @save_pct= @@GLOBAL.innodb_max_dirty_pages_pct;
+SET @save_pct_lwm= @@GLOBAL.innodb_max_dirty_pages_pct_lwm;
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = 0.0;
+SET GLOBAL innodb_max_dirty_pages_pct = 0.0;
+SET GLOBAL innodb_buffer_pool_size = @old_innodb_buffer_pool_size;
+SET GLOBAL innodb_adaptive_hash_index = @old_innodb_adaptive_hash_index;
+SET GLOBAL innodb_max_dirty_pages_pct = @save_pct;
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = @save_pct_lwm;
Index: mariadb-10.11.11/mysql-test/suite/innodb/r/innodb_buffer_pool_resize_temporary.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/r/innodb_buffer_pool_resize_temporary.result
+++ mariadb-10.11.11/mysql-test/suite/innodb/r/innodb_buffer_pool_resize_temporary.result
@@ -4,7 +4,32 @@ SET GLOBAL innodb_limit_optimistic_inser
 SET GLOBAL innodb_buffer_pool_size=16777216;
 CREATE TEMPORARY TABLE t1 (a INT PRIMARY KEY) ENGINE=InnoDB;
 INSERT INTO t1 SELECT seq FROM seq_1_to_200;
+SET GLOBAL innodb_max_purge_lag_wait=0;
+SET @save_pct= @@GLOBAL.innodb_max_dirty_pages_pct;
+SET @save_pct_lwm= @@GLOBAL.innodb_max_dirty_pages_pct_lwm;
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = 0.0;
+SET GLOBAL innodb_max_dirty_pages_pct = 0.0;
+SHOW STATUS LIKE 'innodb_buffer_pool_resize_status';
+Variable_name	Value
+Innodb_buffer_pool_resize_status	
+connect con1,localhost,root;
+SET DEBUG_SYNC='buf_pool_shrink_before_wakeup SIGNAL blocked WAIT_FOR go';
 SET GLOBAL innodb_buffer_pool_size=8388608;
+connection default;
+SET DEBUG_SYNC='now WAIT_FOR blocked';
+SHOW STATUS LIKE 'innodb_buffer_pool_resize_status';
+Variable_name	Value
+Innodb_buffer_pool_resize_status	Withdrawing blocks. (505/505).
+SET DEBUG_SYNC='now SIGNAL go';
+connection con1;
+disconnect con1;
+connection default;
+SHOW STATUS LIKE 'innodb_buffer_pool_resize_status';
+Variable_name	Value
+Innodb_buffer_pool_resize_status	
+SET DEBUG_SYNC=RESET;
+SET GLOBAL innodb_max_dirty_pages_pct = @save_pct;
+SET GLOBAL innodb_max_dirty_pages_pct_lwm = @save_pct_lwm;
 SELECT COUNT(*),MIN(a),MAX(a) FROM t1;
 COUNT(*)	MIN(a)	MAX(a)
 200	1	200
Index: mariadb-10.11.11/mysql-test/suite/innodb/r/lock_memory_debug.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/r/lock_memory_debug.result
+++ mariadb-10.11.11/mysql-test/suite/innodb/r/lock_memory_debug.result
@@ -5,7 +5,7 @@ call mtr.add_suppression("\\[Warning\\]
 CREATE TABLE t1 (col1 INT) ENGINE=InnoDB;
 INSERT INTO t1 VALUES (1),(2),(3),(4),(5);
 SET STATEMENT debug_dbug='+d,innodb_skip_lock_bitmap' FOR
-INSERT INTO t1 SELECT a.* FROM t1 a, t1 b, t1 c, t1 d, t1 e, t1 f, t1 g LIMIT 45000;
+INSERT INTO t1 SELECT a.* FROM t1 a, t1 b, t1 c, t1 d, t1 e, t1 f, t1 g;
 ERROR HY000: The total number of locks exceeds the lock table size
 SELECT COUNT(*) FROM t1;
 COUNT(*)
Index: mariadb-10.11.11/mysql-test/suite/innodb/r/log_upgrade_101_flags.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/r/log_upgrade_101_flags.result
+++ mariadb-10.11.11/mysql-test/suite/innodb/r/log_upgrade_101_flags.result
@@ -1,7 +1,7 @@
 call mtr.add_suppression("InnoDB: The change buffer is corrupted");
 call mtr.add_suppression("InnoDB: Tablespace size stored in header is 768 pages, but the sum of data file sizes is 384 pages");
 call mtr.add_suppression("InnoDB: adjusting FSP_SPACE_FLAGS of file");
-# restart: --innodb-data-home-dir=MYSQLTEST_VARDIR/tmp/log_upgrade --innodb-log-group-home-dir=MYSQLTEST_VARDIR/tmp/log_upgrade --innodb-force-recovery=5 --innodb-log-file-size=4m --innodb_page_size=32k --innodb_buffer_pool_size=10M
+# restart: --innodb-data-home-dir=MYSQLTEST_VARDIR/tmp/log_upgrade --innodb-log-group-home-dir=MYSQLTEST_VARDIR/tmp/log_upgrade --innodb-force-recovery=5 --innodb-log-file-size=4m --innodb_page_size=32k --innodb_buffer_pool_size=11M
 SELECT COUNT(*) FROM INFORMATION_SCHEMA.ENGINES
 WHERE engine = 'innodb'
 AND support IN ('YES', 'DEFAULT', 'ENABLED');
Index: mariadb-10.11.11/mysql-test/suite/innodb/r/recovery_memory.result
===================================================================
--- mariadb-10.11.11.orig/mysql-test/suite/innodb/r/recovery_memory.result
+++ mariadb-10.11.11/mysql-test/suite/innodb/r/recovery_memory.result
@@ -12,7 +12,7 @@ END LOOP
 connect con1,localhost,root,,,;
 CALL dorepeat();
 connection default;
-# restart: --innodb_buffer_pool_size=5242880
+# restart: --innodb_buffer_pool_size=6m
 DROP TABLE t1;
 DROP PROCEDURE dorepeat;
 #
